// -*-C++-*- cxxrt/algorithm.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1999 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Make this implementation independent from the <algorithm> header
// Version: $Id: algorithm.h,v 1.4 2000/07/15 07:51:21 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_ALGORITHM_H__)
#define _CXXRT_ALGORITHM_H__ 1

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_IIt, class _CS_OIt>
inline _CS_OIt
_CS_copy(_CS_IIt _CS_b, _CS_IIt _CS_e,
							 _CS_OIt _CS_d)
{
	while (_CS_b != _CS_e)
	{
		*_CS_d = *_CS_b;
		++_CS_d;
		++_CS_b;
	}
	return _CS_d;
}

template <class _CS_IIt, class _CS_T>
inline _CS_IIt
_CS_find(_CS_IIt _CS_b, _CS_IIt _CS_e,
							 _CS_T const& _CS_val)
{
	while (_CS_b != _CS_e && *_CS_b != _CS_val)
		++_CS_b;
	return _CS_b;
}

template <class _CS_IIt, class _CS_T>
inline _CS_IIt
_CS_fill_n(_CS_IIt _CS_b, _CS_IIt _CS_e,
								 _CS_T const& _CS_val)
{
	for (; _CS_b != _CS_e; ++_CS_b)
		*_CS_b = _CS_val;
	return _CS_b;
}

// --------------------------------------------------------------------------

template <class _CS_It, class _CS_Val>
inline _CS_It
_CS_partition(_CS_It _CS_b, _CS_It _CS_e)
{
	_CS_Val _CS_tmp;

	for (--_CS_e; _CS_b < _CS_e; )
		{
			while (*_CS_b < *_CS_e)
				--_CS_e;
			;
			if (_CS_b != _CS_e)
				{
					if (*_CS_b == *_CS_e)
						++_CS_b;
					else
					{
						_CS_tmp = *_CS_b;
						*_CS_b = * _CS_e;
						*_CS_e = _CS_tmp;
					}
				}
			
			while (*_CS_b < *_CS_e)
				++_CS_b;
			if (_CS_b != _CS_e)
				{
					if (*_CS_b == *_CS_e)
						--_CS_e;
					else
						{
							_CS_tmp = *_CS_b;
							*_CS_b = * _CS_e;
							*_CS_e = _CS_tmp;
						}
				}
		}
	return _CS_b;
}

template <class _CS_It, class _CS_Val>
void
_CS_quicksort(_CS_It _CS_b, _CS_It _CS_e, _CS_Val const&);

template <class _CS_It>
inline void
_CS_quicksort(_CS_It _CS_b, _CS_It _CS_e)
{
	if (_CS_b != _CS_e)
		_CS_quicksort(_CS_b, _CS_e, *_CS_b);
}

template <class _CS_It, class _CS_Val>
void
_CS_quicksort(_CS_It _CS_b, _CS_It _CS_e, _CS_Val const&)
{
	if (_CS_b != _CS_e)
		{
			_CS_It _CS_mid = _CS_partition<_CS_It, _CS_Val>(_CS_b, _CS_e);
			_CS_quicksort(_CS_b, _CS_mid);
			_CS_quicksort(++_CS_mid, _CS_e);
		}
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_ALGORITHM_H__ */
