// -*-C++-*- include/cxxrt/c_lfile.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1999 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  A simple buffered file used in reading locale data
// Version: $Id: c_lfile.h,v 1.2 1999/09/28 23:05:25 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_C_LFILE_H__)
#define _CXXRT_C_LFILE_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRT_SYSFILE_H__)
#  include <cxxrt/sysfile.h>
#endif

// --------------------------------------------------------------------------

struct _Locale_file
{
public:
  _Locale_file();
  ~_Locale_file();
	
  bool _CS_open(char const*);    // try to open the file
  bool _CS_failed() const;       // return whether a read operation failed
  bool _CS_is_open() const;      // return whether the file is open
  
  bool _CS_read(char&);          // read a single character
  bool _CS_read(int&);           // read a simple formatted integer and the following whitespace
  bool _CS_read(char*, int);     // read a string of length len and the following whitespace

  char const* _CS_read_string(); // read string into new[]ed buffer
  
private:
  _Locale_file(_Locale_file const&);
  void operator= (_Locale_file const&);

  char*                           _CS_m_buffer;
  char*                           _CS_m_current;
  char*                           _CS_m_end;
  _CXXRT_STD_NAME:: _CS_sysfile _CS_m_file;
  bool                            _CS_m_ok;
};

// --------------------------------------------------------------------------

#endif /* _CXXRT_C_LFILE_H__ */
