// -*-C++-*- cxxrt/c_locdef.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Definitions which have to be visible in public headers

// Note: The implementation from Matt Austern (SGI) uses the same
// layer. Is is done to support switching implementations. The
// definition of this interface is from Matt Austern.

// This implementation uses a portable approach despite what is said
// in Matt's documentation: The "trick" is to ignore what is already
// provided by the platform...
// --------------------------------------------------------------------------

#if !defined(_CXXRT_C_LOCDEF_H__)
#define _CXXRT_C_LOCDEF_H__ 1

// --------------------------------------------------------------------------

#define _Locale_SPACE  (1<<0)
#define _Locale_PRINT  (1<<1)
#define _Locale_CNTRL  (1<<2)
#define _Locale_UPPER  (1<<3)
#define _Locale_LOWER  (1<<4)
#define _Locale_ALPHA  (1<<5)
#define _Locale_DIGIT  (1<<6)
#define _Locale_PUNCT  (1<<7)
#define _Locale_XDIGIT (1<<8)
#define _Locale_BLANK  (1<<9)

typedef unsigned short _Locale_mask_t;

// --------------------------------------------------------------------------

#endif /* _CXXRT_C_LOCDEF_H__ */
