// -*-C++-*- cxxrt/copy.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 2000 Dietmar Kuehl, Phaidros Software AG > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Phaidros Software AG make > 
// <!! no representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar_kuehl@yahoo.com 
// Title:  Optimized implementation of the copy() algorithm
// Version: $Id: copy.h,v 1.1 2000/08/08 00:02:35 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_COPY_H)
#define _CXXRT_COPY_H 1

namespace _Cxxrt_algorithm
{

  // ------------------------------------------------------------------------
  
  template <class _CS_InIt, class _CS_OutIt>
  _CS_OutIt
  copy(_CS_InIt _CS_beg, _CS_InIt _CS_end, _CS_OutIt _CS_to)
  {
    for (; _CS_beg != _CS_end; ++_CS_beg, ++_CS_to)
      *_CS_to = *_CS_beg;
    return _CS_to;
  }

  template <class _CS_InIt> class _CXXRT_STD reverse_iterator;

  template <class _CS_InIt, class _CS_OutIt>
  _CS_OutIt
  copy(_CXXRT_STD reverse_iterator<_CS_InIt> _CS_beg,
       _CXXRT_STD reverse_iterator<_CS_InIt> _CS_end,
       _CS_OutIt _CS_to)
  {
    _CS_InIt _CS_rbeg = _CS_beg.base();
    _CS_InIt _CS_rend = _CS_end.base();
    
    for (; _CS_rbeg != _CS_rend; ++_CS_to)
      *_CS_to = *--_CS_rbeg;

    return _CS_to;
  }

  // ------------------------------------------------------------------------

} // namespace _Cxxrt_algorithm

#endif /* _CXXRT_COPY_H */
