// -*-C++-*- cxxrt/ctype_base.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Declaration of the class common to all ctype facets

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_CTYPE_BASE_H__)
#define _CXXRT_CTYPE_BASE_H__ 1

#if !defined(_CXXRTCF_H__)
#  include "cxxrtcf.h"
#endif
#if !defined(_CXXRT_C_LOCDEF_H__)
#  include <cxxrt/c_locdef.h>
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------
// The class code(ctype_base) defines a bitmask type used by all ctype
// facets (22.2.1).

class ctype_base
{
public:
#if _CXXRT_HAS_CONST_EXPRESSION_MEMBER == 0
  enum mask
  {
    space  = _Locale_SPACE,
    print  = _Locale_PRINT,
    cntrl  = _Locale_CNTRL,
    upper  = _Locale_UPPER,
    lower  = _Locale_LOWER,
    alpha  = _Locale_ALPHA,
    digit  = _Locale_DIGIT,
    punct  = _Locale_PUNCT,
    xdigit = _Locale_XDIGIT,
    alnum  = alpha | digit,
    graph  = alnum | punct
  };
#else
  typedef _Locale_mask_t mask;

  static mask const  space  = _Locale_SPACE;
  static mask const  print  = _Locale_PRINT;
  static mask const  cntrl  = _Locale_CNTRL;
  static mask const  upper  = _Locale_UPPER;
  static mask const  lower  = _Locale_LOWER;
  static mask const  alpha  = _Locale_ALPHA;
  static mask const  digit  = _Locale_DIGIT;
  static mask const  punct  = _Locale_PUNCT;
  static mask const  xdigit = _Locale_XDIGIT;
  static mask const  alnum  = alpha | digit;
  static mask const  graph  = alnum | punct;
#endif
};

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_CTYPE_BASE_H__ */
