// -*-C++-*- cxxrt/extractor.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1999 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  A helper class to get individual characters
// Version: $Id: extractor.h,v 1.2 1999/09/28 23:05:26 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_EXTRACTOR_H__)
#define _CXXRT_EXTRACTOR_H__ 1

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
class _CS_extractor
{
public:
  _CS_extractor(_CS_It& _CS_b, _CS_It& _CS_e, locale const& _CS_l):
    _CS_m_count(0),
    _CS_m_begin(_CS_b),
    _CS_m_end(_CS_e),
    _CS_m_cache(use_facet<_CS_cache<_CS_cT> >(_CS_l))
  {
  }

  bool _CS_get_current(unsigned int& _CS_val)
    {
      if (_CS_m_begin == _CS_m_end)
        return false;
      _CS_val = _CS_m_cache._CS_find(*_CS_m_begin);
      return true;
    }
  bool _CS_get_next(unsigned int& _CS_val)
    {
      ++_CS_m_begin;
      return _CS_get_current(_CS_val);
    }

  int _CS_get_count() const { return _CS_m_count; }
  void _CS_init_count(unsigned int _CS_c) { _CS_m_count = _CS_c; }
  bool _CS_get_next_counted(unsigned int& _CS_val)
    {
      if (--_CS_m_count == 0)
        return false;
      return _CS_get_next(_CS_val);
    }

private:
  int _CS_m_count;
  _CS_It& _CS_m_begin;
  _CS_It& _CS_m_end;
  _CS_cache<_CS_cT> const& _CS_m_cache;
};

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_EXTRACTOR_H__ */
