// -*-C++-*- cxxrt/fstr_fwd.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Forward declarations for the file streams

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_FSTR_FWD_H__)
#define _CXXRT_FSTR_FWD_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRTCF_CTRAITS_FWD_H__)
#  include <cxxrt/ctraits_fwd.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_charT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_charT>) >
class basic_filebuf;
template <class _CS_charT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_charT>) >
class basic_ifstream;
template <class _CS_charT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_charT>) >
class basic_ofstream;
template <class _CS_charT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_charT>) >
class basic_fstream;

// --------------------------------------------------------------------------

typedef basic_filebuf<char, char_traits<char> > filebuf;
typedef basic_ifstream<char, char_traits<char> > ifstream;
typedef basic_ofstream<char, char_traits<char> > ofstream;
typedef basic_fstream<char, char_traits<char> > fstream;

typedef basic_filebuf<wchar_t, char_traits<wchar_t> > wfilebuf;
typedef basic_ifstream<wchar_t, char_traits<wchar_t> > wifstream;
typedef basic_ofstream<wchar_t, char_traits<wchar_t> > wofstream;
typedef basic_fstream<wchar_t, char_traits<wchar_t> > wfstream;

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_FSTR_FWD_H__ */
