// -*-C++-*- iosfwd.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Forward declaration for IOStream stuff 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_IOSFWD_H__)
#define _CXXRT_IOSFWD_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(__CWCHAR__)
#  include <cwchar>
#endif

_CXXRT_NAMESPACE_BEGIN

#if defined(_CRT_STD)
  using _CRT_STD mbstate_t;
  using _CRT_STD wint_t;
#endif

// --------------------------------------------------------------------------

template <class _CS_cT> struct char_traits;
_CXXRT_FULL_SPECIALIZATION struct char_traits<char>;
_CXXRT_FULL_SPECIALIZATION struct char_traits<wchar_t>;
template <class _CS_state_t> class fpos;

typedef fpos<mbstate_t> streampos;
typedef fpos<mbstate_t> wstreampos;

// --------------------------------------------------------------------------
// base classes of the IOStream library:

template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>) >
class basic_ios;

template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>) >
class basic_istream;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>) >
class basic_ostream;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>) >
class basic_iostream;

// --------------------------------------------------------------------------
// typedefs for the 'char' IOStreams:

typedef basic_ios<char, char_traits<char> >       ios;

typedef basic_istream<char, char_traits<char> >   istream;
typedef basic_ostream<char, char_traits<char> >   ostream;
typedef basic_iostream<char, char_traits<char> >  iostream;

// --------------------------------------------------------------------------
// typedefs for the 'wchar_t' IOStreams

typedef basic_ios<wchar_t, char_traits<wchar_t> >      wios;
typedef basic_istream<wchar_t, char_traits<wchar_t> >  wistream;
typedef basic_ostream<wchar_t, char_traits<wchar_t> >  wostream;
typedef basic_iostream<wchar_t, char_traits<wchar_t> > wiostream;

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_IOSFWD_H__ */
