// -*-C++-*- cxxrt/iostream.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Declaration of the class basic_iostream

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_IOSTREAM_H__)
#define _CXXRT_IOSTREAM_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif

#if !defined(_CXXRT_IOSFWD_H__)
#  include <cxxrt/iosfwd.h>
#endif
#if !defined(_CXXRT_ISTREAM_H__)
#  include <cxxrt/istream.h>
#endif
#if !defined(_CXXRT_OSTREAM_H__)
#  include <cxxrt/ostream.h>
#endif

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------

template <class _CS_cT, class _CS_traits>
class basic_iostream:
        public basic_istream<_CS_cT, _CS_traits>,
        public basic_ostream<_CS_cT, _CS_traits>
{
public:
  using basic_istream<_CS_cT, _CS_traits>::char_type;

  explicit basic_iostream(basic_streambuf<_CS_cT, _CS_traits>*);
  virtual ~basic_iostream();
};

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#if defined(_CXXRT_IOSTREAM_IMPL) && !defined(__SRCCXX_IOSTREAM_CC__)
#  include <srccxx/iostream.cc>
#endif

#endif /* _CXXRT_IOSTREAM_H__ */
