// -*-C++-*- cxxrt/iterator.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1999 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  The basic iterator declarations and classes
// Version: $Id: iterator.h,v 1.2 1999/09/28 23:05:26 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_ITERATOR_H__)
#define _CXXRT_ITERATOR_H__ 1

#if 0
#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

struct input_iterator_tag {};
struct output_iterator_tag {};
struct forward_iterator_tag: input_iterator_tag {};
struct bidirectional_iterator_tag: forward_iterator_tag {};
struct random_access_iterator_tag: bidirectional_iterator_tag {};

// --------------------------------------------------------------------------

template <class _CS_It>
struct iterator_traits
{
	typedef typename _CS_It::difference_type   difference_type;
	typedef typename _CS_It::value_type        value_type;
	typedef typename _CS_It::pointer           pointer;
	typedef typename _CS_It::reference         reference;
	typedef typename _CS_It::iterator_category iterator_category;
};

// --------------------------------------------------------------------------

template <class _CS_T>
struct iterator_traits<_CS_T*>
{
	typedef ptrdiff_t                  difference_type;
	typedef _CS_T                value_type;
	typedef _CS_T*               pointer;
	typedef _CS_T&               reference;
	typedef random_access_iterator_tag iterator_category;
};

template <class _CS_T>
struct iterator_traits<_CS_T const*>
{
	typedef ptrdiff_t                  difference_type;
	typedef _CS_T                value_type;
	typedef _CS_T const*         pointer;
	typedef _CS_T const&         reference;
	typedef random_access_iterator_tag iterator_category;
};

// --------------------------------------------------------------------------

template <class _CS_Cat, class _CS_T, class _CS_Dist = ptrdiff_t,
          class _CS_Ptr = _CS_T*, class _CS_Ref = _CS_T&>
struct iterator
{
	typedef _CS_Dist different_type;
	typedef _CS_T    value_type;
	typedef _CS_Ptr  pointer;
	typedef _CS_Ref  reference;
	typedef _CS_Cat  iterator_category;
};

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END
#else
#  include <iterator>
#endif

#endif /* _CXXRT_ITERATOR_H__ */
