// -*-C++-*- cxxrt/iterhelp.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 2000 Dietmar Kuehl, Phaidros Software AG > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Phaidros Software AG make > 
// <!! no representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar_kuehl@yahoo.com 
// Title:  Auxiliary classes for specialized algorithms
// Version: $Id: iterhelp.h,v 1.1 2000/08/08 00:02:35 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_ITERHELP_H_)
#define _CXXRT_ITERHELP_H_ 1

namespace _Cxxrt_algorithm
{

  template <bool> struct _Cxxrt_bool {};
  
  // ------------------------------------------------------------------------
  
  template <typename _CS_Iterator>
  class _Cxxrt_iterhelper
  {
  public:
    typedef _Cxxrt_bool<true> _Cxxrt_fundamental;
    typedef _CS_Iterator      iterator;
    
    _Cxxrt_iterhelper(_CS_Iterator _CS_beg, _CS_Iterator _CS_end):
      _CS_m_beg(_CS_beg),
      _CS_m_end(_CS_end)
    {
    }

    operator void const*() const { return _CS_m_beg == _CS_m_end? 0: this; }
    _Cxxrt_iterhelper& operator++() { ++_CS_m_beg; return *this; }
    _CS_Iterator       begin() { return _CS_m_beg; }
    _CS_Iterator       end()   { return _CS_m_end; }
    _CS_Iterator       _Cxxrt_done(_CS_Iterator _CS_it) const { return _CS_it; }

  private:
    _CS_Iterator _CS_m_beg;
    _CS_Iterator _CS_m_end;
  };

  // ------------------------------------------------------------------------

} // namespace _Cxxrt_algorithm

#endif /* _CXXRT_ITERHELP_H_ */
