// -*-C++-*- cxxrt/num_get.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Declarations for the num_get facet

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_NUM_GET_H__)
#define _CXXRT_NUM_GET_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRT_LOCALE_H__)
#  include <cxxrt/locale.h>
#endif
#if !defined(_CXXRT_IOS_BASE_H__)
#  include <cxxrt/ios_base.h>
#endif
#if !defined(_CXXRT_SBIT_FWD_H__)
#  include <cxxrt/sbit_fwd.h>
#endif
#if !defined(_CXXRT_BSTR_FWD)
#  include <cxxrt/bstr_fwd.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT,
  class _CS_InIt _CXXRT_TEMPLATE_DEF_ARG(istreambuf_iterator<_CS_cT>) >
class num_get: public locale::facet
{
public:
  typedef _CS_cT char_type;
  typedef _CS_InIt  iter_type;

  _CXXRT_EXPLICIT num_get(size_t refs = 0);

  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, bool&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, long&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, unsigned short&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, unsigned int&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, unsigned long&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, float&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, double&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, long double&) const;
  iter_type get(iter_type, iter_type, ios_base&, ios_base::iostate&, void*&) const;

  static locale::id id;

protected:
  typedef ios_base::iostate iostate; // just to fit the members on one line
  ~num_get();

  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, bool&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, long&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, unsigned short&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, unsigned int&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, unsigned long&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, float&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, double&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, long double&) const;
  virtual iter_type do_get(iter_type, iter_type, ios_base&, iostate&, void*&) const;
};

// --------------------------------------------------------------------------

template <>
inline bool has_facet<num_get<char> >(locale const&) 
{
  return true;
}

template <>
inline num_get<char> const& use_facet<num_get<char> >(locale const& _CS_l)
{
  return _CS_use_facet<num_get<char> >(_CS_l);
}

template <>
inline bool has_facet<num_get<wchar_t> >(locale const&) 
{
  return true;
}
template <>
inline num_get<wchar_t> const& use_facet<num_get<wchar_t> >(locale const& _CS_l)
{
  return _CS_use_facet<num_get<wchar_t> >(_CS_l);
}

#if 0
template <>
inline bool has_facet<num_get<char, char const*> >(locale const&) 
{
  return true;
}

template <>
inline num_get<char, char const*> const& use_facet<num_get<char, char const*> >(locale const& _CS_l)
{
  return _CS_use_facet<num_get<char, char const*> >(_CS_l);
}
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#if defined(_CXXRT_LOCALE_IMPL) && !defined(__SRCCXX_NUM_GET_CC__)
#  include <srccxx/num_get.cc>
#endif

#endif /* _CXXRT_NUM_GET_H__ */
