// -*-C++-*- cxxrt/num_put.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Declarations for the num_put Facet

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_NUM_PUT_H__)
#define _CXXRT_NUM_PUT_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRT_LOCALE_H__)
#  include <cxxrt/locale.h>
#endif
#if !defined(_CXXRT_SBIT_FWD_H__)
#  include <cxxrt/sbit_fwd.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

class ios_base;

// --------------------------------------------------------------------------

template <class _CS_cT,
  class _CS_It _CXXRT_TEMPLATE_DEF_ARG(ostreambuf_iterator<_CS_cT>) >
class num_put: public locale::facet
{
public:
  typedef _CS_cT char_type;
  typedef _CS_It iter_type;

  _CXXRT_EXPLICIT num_put(size_t refs = 0);

  iter_type put(iter_type, ios_base&, char_type, bool) const;
#if 1
  iter_type put(iter_type, ios_base&, char_type, long) const;
#else
  iter_type put(iter_type _CS_oit, ios_base& _CS_fmt, char_type _CS_fill, long _CS_val) const
{
  return do_put(_CS_oit, _CS_fmt, _CS_fill, _CS_val);
}
#endif
  iter_type put(iter_type, ios_base&, char_type, unsigned long) const;
  iter_type put(iter_type, ios_base&, char_type, double) const;
  iter_type put(iter_type, ios_base&, char_type, long double) const;
  iter_type put(iter_type, ios_base&, char_type, void const*) const;

  static locale::id id;

protected:
  virtual ~num_put();

  virtual iter_type do_put(iter_type, ios_base&, char_type, bool) const;
  virtual iter_type do_put(iter_type, ios_base&, char_type, long) const;
  virtual iter_type do_put(iter_type, ios_base&, char_type, unsigned long) const;
  virtual iter_type do_put(iter_type, ios_base&, char_type, double) const;
  virtual iter_type do_put(iter_type, ios_base&, char_type, long double) const;
  virtual iter_type do_put(iter_type, ios_base&, char_type, void const*) const;
};

// --------------------------------------------------------------------------

template <>
inline bool has_facet<num_put<char> >(locale const&) 
{
  return true;
}

template <>
inline num_put<char> const& use_facet<num_put<char> >(locale const& _CS_l)
{
  return _CS_use_facet<num_put<char> >(_CS_l);
}

template <>
inline bool has_facet<num_put<wchar_t> >(locale const&) 
{
  return true;
}
template <>
inline num_put<wchar_t> const& use_facet<num_put<wchar_t> >(locale const& _CS_l)
{
  return _CS_use_facet<num_put<wchar_t> >(_CS_l);
}

#if 0
template <>
inline bool has_facet<num_put<char, char*> >(locale const&) 
{
  return true;
}

template <>
inline num_put<char, char*> const& use_facet<num_put<char, char*> >(locale const& _CS_l)
{
  return _CS_use_facet<num_put<char, char*> >(_CS_l);
}
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#if defined(_CXXRT_LOCALE_IMPL) && !defined(__SRCCXX_NUM_PUT_CC__)
#  include <srccxx/num_put.cc>
#endif

#endif /* _CXXRT_NUM_PUT_H__ */
