// -*-C++-*- cxxrt/ostream_it.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1999 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Definition of the class ostream_iterator
// Version: $Id: ostream_it.h,v 1.2 1999/09/28 23:05:26 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_OSTREAM_IT_H__)
#define _CXXRT_OSTREAM_IT_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif

#if !defined(_CXXRT_ITERATOR_H__)
#  include <cxxrt/iterator.h>
#endif
#if !defined(_CXXRT_CTRAITS_H__)
#  include <cxxrt/ctraits.h>
#endif
#include <iosfwd>

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_T, class _CS_cT = char,
	class _CS_traits = char_traits<_CS_cT> >
class ostream_iterator: public iterator<input_iterator_tag, void, void, void, void>
{
public:
  typedef basic_ostream<_CS_cT, _CS_traits> ostream_type;
	typedef _CS_cT        char_type;
	typedef _CS_traits    traits_type;
	typedef void                different_type;
	typedef void                value_type;
	typedef void                pointer;
	typedef void                reference;
	typedef output_iterator_tag iterator_category;
};

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_OSTREAM_IT_H__ */
