// -*-C++-*- cxxrt/sstr_fwd.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Forward declaration of the string stream types

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_SSTR_FWD_H__)
#define _CXXRT_SSTR_FWD_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRT_BSTR_FWD_H__)
#  include <cxxrt/bstr_fwd.h>
#endif
#if !defined(_CXXRTCF_CTRAITS_FWD_H__)
#  include <cxxrt/ctraits_fwd.h>
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------
// allocator:

template <class _CS_T> class allocator;

// --------------------------------------------------------------------------

#if defined(__STL_USE_STD_ALLOCATORS)
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(allocator<_CS_cT>) >
class basic_stringbuf;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(allocator<_CS_cT>) >
class basic_istringstream;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(allocator<_CS_cT>) >
class basic_ostringstream;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(allocator<_CS_cT>) >
class basic_stringstream;
#else
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(alloc) >
class basic_stringbuf;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(alloc) >
class basic_istringstream;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(alloc) >
class basic_ostringstream;
template <class _CS_cT,
          class _CS_traits _CXXRT_TEMPLATE_DEF_ARG(char_traits<_CS_cT>),
          class _CS_alloc  _CXXRT_TEMPLATE_DEF_ARG(alloc) >
class basic_stringstream;
#endif

#if defined(__STL_USE_STD_ALLOCATORS)
typedef basic_stringbuf<char, char_traits<char>, allocator<char> >
        stringbuf;
typedef basic_istringstream<char, char_traits<char>, allocator<char> >
        istringstream;
typedef basic_ostringstream<char, char_traits<char>, allocator<char> >
        ostringstream;
typedef basic_stringstream<char, char_traits<char>, allocator<char> >
        stringstream;

typedef basic_stringbuf<wchar_t, char_traits<wchar_t>, allocator<wchar_t> >
        wstringbuf;
typedef basic_istringstream<wchar_t, char_traits<wchar_t>, allocator<wchar_t> >
        wistringstream;
typedef basic_ostringstream<wchar_t, char_traits<wchar_t>, allocator<wchar_t> >
        wostringstream;
typedef basic_stringstream<wchar_t, char_traits<wchar_t>, allocator<wchar_t> >
        wstringstream;
#else
typedef basic_stringbuf<char, char_traits<char>, alloc>
        stringbuf;
typedef basic_istringstream<char, char_traits<char>, alloc>
        istringstream;
typedef basic_ostringstream<char, char_traits<char>, alloc>
        ostringstream;
typedef basic_stringstream<char, char_traits<char>, alloc>
        stringstream;

typedef basic_stringbuf<wchar_t, char_traits<wchar_t>, alloc>
        wstringbuf;
typedef basic_istringstream<wchar_t, char_traits<wchar_t>, alloc>
        wistringstream;
typedef basic_ostringstream<wchar_t, char_traits<wchar_t>, alloc>
        wostringstream;
typedef basic_stringstream<wchar_t, char_traits<wchar_t>, alloc>
        wstringstream;
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_SSTR_FWD_H__ */
