// -*-C++-*- cxxrt/stringio.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Functions for basic_string I/O which should actually be in the <string> header

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_STRINGIO_H__)
#define _CXXRT_STRINGIO_H__ 1

// --------------------------------------------------------------------------

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRT_IOSFWD_H__)
#  include <cxxrt/iosfwd.h>
#endif
#if !defined(_CXXRT_BSTR_FWD_H__)
#  include <cxxrt/bstr_fwd.h>
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------
// this should actually be in the <string> header:

template <class _CS_charT, class _CS_traits, class _CS_alloc>
basic_istream<_CS_charT, _CS_traits>&
getline(basic_istream<_CS_charT, _CS_traits>&,
        basic_string<_CS_charT, _CS_traits, _CS_alloc>&,
        _CS_charT);

template <class _CS_charT, class _CS_traits, class _CS_alloc>
basic_istream<_CS_charT, _CS_traits>&
getline(basic_istream<_CS_charT, _CS_traits>&,
        basic_string<_CS_charT, _CS_traits, _CS_alloc>&);

template <class _CS_charT, class _CS_traits, class _CS_alloc>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>&,
            basic_string<_CS_charT, _CS_traits, _CS_alloc> const&);

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_STRINGIO_H__ */
