// -*-C++-*- cxxrt/sysfile.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Declaration of a class for system dependent file access

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_SYSFILE_H__)
#define _CXXRT_SYSFILE_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif
#if !defined(_CXXRT_IOS_BASE_H__)
#  include <cxxrt/ios_base.h>
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

class _CS_sysfile
{
public:
  _CS_sysfile();
  _CS_sysfile(char const*, ios_base::openmode);
  ~_CS_sysfile();

  bool         _CS_open(char const*, ios_base::openmode);
  bool         _CS_close();
  bool         _CS_is_open() const;

  streamsize   _CS_bufsiz() const;
  streamsize   _CS_read(char*, streamsize);
  streamsize   _CS_write(char const*, streamsize);
  _CXXRT_off_t _CS_seek(_CXXRT_off_t, ios_base::seekdir);

#if !defined(_MSC_VER)
  template <class _CS_second_cT>
  streamsize _CS_read(_CS_second_cT*, streamsize) { throw_failure("can only read 'char'"); return 0; }
  template <class _CS_second_cT>
  streamsize _CS_write(_CS_second_cT const*, streamsize) { throw_failure("can only write 'char'"); return 0; }
#endif

private:
  void throw_failure(char const*);
  ios_base::openmode  _CS_m_mode;
  int                 _CS_m_fd;
  streamsize          _CS_m_bufsiz;
};

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* _CXXRT_SYSFILE_H__ */
