// -*-C++-*- cxxrt/time_put.h
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Declarations for the time_put facet

// -------------------------------------------------------------------------- 

#if !defined(_CXXRT_TIME_PUT_H__)
#define _CXXRT_TIME_PUT_H__ 1

#if !defined(_CXXRTCF_H__)
#  include <cxxrtcf.h>
#endif 
#if !defined(_CXXRT_LOCALE_H__)
#  include <cxxrt/locale.h>
#endif 
#if !defined(_CXXRT_SBIT_FWD_H__)
#  include <cxxrt/sbit_fwd.h>
#endif 
#if !defined(_CXXRT_IOS_BASE_H__)
#  include <cxxrt/ios_base.h>
#endif 
#include <ctime>

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT,
	        class _CS_It _CXXRT_TEMPLATE_DEF_ARG(ostreambuf_iterator<_CS_cT>) >
class time_put: public locale::facet
{
public:
	typedef _CS_cT char_type;
	typedef _CS_It iter_type;

	static locale::id id;

	_CXXRT_EXPLICIT time_put(size_t = 0);

	iter_type put(iter_type, ios_base&, char_type, tm const*, char_type const*, char_type const*) const;
	iter_type put(iter_type, ios_base&, char_type, tm const*, char, char = 0) const;

protected:
	virtual iter_type do_put(iter_type, ios_base&, char_type, tm const*, char, char) const;
};

// --------------------------------------------------------------------------

template <class _CS_cT,
	        class _CS_It _CXXRT_TEMPLATE_DEF_ARG(ostreambuf_iterator<_CS_cT>) >
class time_put_byname: public time_put<_CS_cT, _CS_It>
{
public:
	typedef _CS_cT char_type;
	typedef _CS_It iter_type;

	_CXXRT_EXPLICIT time_put_byname(char const *, size_t = 0);

protected:
	virtual iter_type do_put(iter_type, ios_base&, char_type, tm const*, char, char) const;
};

// --------------------------------------------------------------------------

template <>
inline bool has_facet<time_put<char> >(locale const&) 
{
  return true;
}

template <>
inline time_put<char> const& use_facet<time_put<char> >(locale const& _CS_l)
{
  return _CS_use_facet<time_put<char> >(_CS_l);
}

template <>
inline bool has_facet<time_put<wchar_t> >(locale const&) 
{
  return true;
}
template <>
inline time_put<wchar_t> const& use_facet<time_put<wchar_t> >(locale const& _CS_l)
{
  return _CS_use_facet<time_put<wchar_t> >(_CS_l);
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#if defined(_CXXRT_LOCALE_IMPL) && !defined(__SRCCXX_TIME_PUT_CC__)
#  include <srccxx/time_put.cc>
#endif

#endif /* _CXXRT_TIME_PUT_H__ */
