// -*-C++-*- srccxx/codecvt.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementation of common codecvt functions

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_CODECVT_CC__)
#define __SRCCXX_CODECVT_CC__ 1

// --------------------------------------------------------------------------

#if !defined(_CXXRT_CODECVT_H__)
#  include <cxxrt/codecvt.h>
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_internT, class _CS_externT, class _CS_stateT>
codecvt_base::result codecvt<_CS_internT, _CS_externT, _CS_stateT>::out(
	state_type &_CS_state,
	intern_type const *_CS_fbeg, intern_type const *_CS_fend, intern_type const *&_CS_fnext,
	extern_type *_CS_tbeg, extern_type *_CS_tend, extern_type *&_CS_tnext) const
{
	return do_out(_CS_state,
								_CS_fbeg, _CS_fend, _CS_fnext,
								_CS_tbeg, _CS_tend, _CS_tnext);
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
codecvt_base::result codecvt<_CS_internT, _CS_externT, _CS_stateT>::unshift(
	state_type &_CS_state,
	extern_type *_CS_tbeg, extern_type *_CS_tend, extern_type *&_CS_tnext) const
{
	return do_unshift(_CS_state,
										_CS_tbeg, _CS_tend, _CS_tnext);
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
codecvt_base::result codecvt<_CS_internT, _CS_externT, _CS_stateT>::in(
	state_type &_CS_state,
	extern_type const *_CS_fbeg, extern_type const *_CS_fend, extern_type const *&_CS_fnext,
	intern_type *_CS_tbeg, intern_type *_CS_tend, intern_type *&_CS_tnext) const
{
	return do_in(_CS_state,
							 _CS_fbeg, _CS_fend, _CS_fnext,
							 _CS_tbeg, _CS_tend, _CS_tnext);
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
codecvt<_CS_internT, _CS_externT, _CS_stateT>::~codecvt()
{
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
int codecvt<_CS_internT, _CS_externT, _CS_stateT>::encoding() const throw()
{
	return do_encoding();
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
bool codecvt<_CS_internT, _CS_externT, _CS_stateT>::always_noconv() const throw()
{
	return do_always_noconv();
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
int codecvt<_CS_internT, _CS_externT, _CS_stateT>::length(
	state_type const &_CS_state,
	extern_type const *_CS_beg, extern_type const *_CS_end,
	size_t _CS_max) const
{
	return do_length(_CS_state, _CS_beg, _CS_end, _CS_max);
}

template <class _CS_internT, class _CS_externT, class _CS_stateT>
int codecvt<_CS_internT, _CS_externT, _CS_stateT>::max_length() const throw()
{
	return do_max_length();
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_CODECVT_CC__ */
