// -*-C++-*- srccxx/collate.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/collate category

// Note: Currently, this is only a stub for the real implementation which
//       has still to be done!
// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_COLLATE_CC__)
#define __SRCCXX_COLLATE_CC__ 1

#if !defined(_CXXRT_COLLATE_H__)
#  include <cxxrt/collate.h>
#endif
#if !defined(_CXXRT_ALLOC_H__)
#  include <cxxrt/alloc.h>
#endif
#if !defined(_CXXRT_STRING_H__)
#  include <cxxrt/string.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT>
locale::id collate<_CS_cT>::id;

template <class _CS_cT>
collate<_CS_cT>::collate(size_t _CS_refs):
	locale::facet(_CS_refs)
{
}
	
template <class _CS_cT>
collate<_CS_cT>::~collate()
{
}
	
template <class _CS_cT>
int collate<_CS_cT>::compare(_CS_cT const* _CS_b1, _CS_cT const* _CS_e1,
																	 _CS_cT const* _CS_b2, _CS_cT const* _CS_e2) const
{
	return do_compare(_CS_b1, _CS_e1, _CS_b2, _CS_e2);
}

template <class _CS_cT>
_CXXRT_TYPENAME collate<_CS_cT>::string_type
collate<_CS_cT>::transform(_CS_cT const* _CS_b, _CS_cT const* _CS_e) const
{
	return do_transform(_CS_b, _CS_e);
}

template <class _CS_cT>
long
collate<_CS_cT>::hash(_CS_cT const* _CS_b, _CS_cT const* _CS_e) const
{
	return do_hash(_CS_b, _CS_e);
}

// --------------------------------------------------------------------------
	
template <class _CS_cT>
int collate<_CS_cT>::do_compare(_CS_cT const*, _CS_cT const*,
																			_CS_cT const*, _CS_cT const*) const
{
	return 0; //-dk:TODO
}

template <class _CS_cT>
_CXXRT_TYPENAME collate<_CS_cT>::string_type
collate<_CS_cT>::do_transform(_CS_cT const*, _CS_cT const*) const
{
	return string_type(); //-dk:TODO
}

template <class _CS_cT>
long
collate<_CS_cT>::do_hash(_CS_cT const*, _CS_cT const*) const
{
	return 0; //-dk:TODO
}

// --------------------------------------------------------------------------

template <class _CS_cT>
collate_byname<_CS_cT>::collate_byname(char const*, size_t _CS_refs):
	collate<_CS_cT>(_CS_refs)
{
}
	
template <class _CS_cT>
int collate_byname<_CS_cT>::do_compare(_CS_cT const*, _CS_cT const*,
																						 _CS_cT const*, _CS_cT const*) const
{
	return 0; //-dk:TODO
}

template <class _CS_cT>
_CXXRT_TYPENAME collate<_CS_cT>::string_type
collate_byname<_CS_cT>::do_transform(_CS_cT const*, _CS_cT const*) const
{
	return string_type(); //-dk:TODO
}

template <class _CS_cT>
long
collate_byname<_CS_cT>::do_hash(_CS_cT const*, _CS_cT const*) const
{
	return 0; //-dk:TODO
}


// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_COLLATE_CC__ */
