// -*-C++-*- srccxx/filebuf.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementation of basic_filebuf based on cvtbuf.

// Basically, this class just forwards everything to either the
// "external representation" or to the cvtbuf

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_FILEBUF_CC__)
#define __SRCCXX_FILEBUF_CC__ 1

#if !defined(_CXXRT_FSTREAM_H__)
#  include <cxxrt/fstream.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
basic_filebuf<_CS_charT, _CS_traits>::basic_filebuf()
{
}

template <class _CS_charT, class _CS_traits>
basic_filebuf<_CS_charT, _CS_traits>::~basic_filebuf()
{
  close();
}

template <class _CS_charT, class _CS_traits>
bool
basic_filebuf<_CS_charT, _CS_traits>::is_open() const
{
  return this->_CS_m_er._CS_is_open();
}

template <class _CS_charT, class _CS_traits>
basic_filebuf<_CS_charT, _CS_traits>*
basic_filebuf<_CS_charT, _CS_traits>::open(char const* _CS_fname,
					   ios_base::openmode _CS_mode)
{
  if (_CS_m_er._CS_open(_CS_fname, _CS_mode))
    {
      this->_CS_init();
      return this;
    }
  else
    return 0;
}

template <class _CS_charT, class _CS_traits>
basic_filebuf<_CS_charT, _CS_traits>*
basic_filebuf<_CS_charT, _CS_traits>::close()
{
  if (!is_open())
    return 0;

  this->sync();
  this->_CS_finish();
  return _CS_m_er._CS_close()? this: 0;
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_FILEBUF_CC__ */
