// -*-C++-*- srccxx/iomanip.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Definition of the manipulator functions

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_IOMANIP_CC__)
#define __SRCCXX_IOMANIP_CC__ 1

// --------------------------------------------------------------------------

#if !defined(_CXXRT_IOMANIP_H__)
#  include <cxxrt/iomanip.h>
#endif

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_charT>
_CS_setfill<_CS_charT> setfill(_CS_charT _CS_c)
{
  return _CS_setfill<_CS_charT>(_CS_c);
}

template <class _CS_charT, class _CS_traits>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setfill<_CS_charT> const& _CS_f)
{
  _CS_strm.fill(_CS_f._CS_c);
  return _CS_strm;
}

template <class _CS_charT, class _CS_traits>
basic_istream<_CS_charT, _CS_traits>&
operator>> (basic_istream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setfill<_CS_charT> const& _CS_f)
{
  _CS_strm.fill(_CS_f._CS_c);
  return _CS_strm;
}

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setprecision const& _CS_f)
{
  _CS_strm.precision(_CS_f._CS_precision);
  return _CS_strm;
}

template <class _CS_charT, class _CS_traits>
basic_istream<_CS_charT, _CS_traits>&
operator>> (basic_istream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setprecision const& _CS_f)
{
  _CS_strm.precision(_CS_f._CS_precision);
  return _CS_strm;
}

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setw const& _CS_f)
{
  _CS_strm.width(_CS_f._CS_width);
  return _CS_strm;
}

template <class _CS_charT, class _CS_traits>
basic_istream<_CS_charT, _CS_traits>&
operator>> (basic_istream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setw const& _CS_f)
{
  _CS_strm.width(_CS_f._CS_width);
  return _CS_strm;
}

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_resetiosflags const& _CS_f)
{
  _CS_strm.setf(ios_base::fmtflags(0), _CS_f._CS_flags);
  return _CS_strm;
}

template <class _CS_charT, class _CS_traits>
basic_istream<_CS_charT, _CS_traits>&
operator>> (basic_istream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_resetiosflags const& _CS_f)
{
  _CS_strm.setf(ios_base::fmtflags(0), _CS_f._CS_flags);
  return _CS_strm;
}

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setiosflags const& _CS_f)
{
  _CS_strm.setf(_CS_f._CS_flags);
  return _CS_strm;
}

template <class _CS_charT, class _CS_traits>
basic_istream<_CS_charT, _CS_traits>&
operator>> (basic_istream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setiosflags const& _CS_f)
{
  _CS_strm.setf(_CS_f._CS_flags);
  return _CS_strm;
}

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
basic_ostream<_CS_charT, _CS_traits>&
operator<< (basic_ostream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setbase const& _CS_b)
{
  switch (_CS_b._CS_base)
    {
    case 8:
      oct(_CS_strm);
      break;
    case 10:
      dec(_CS_strm);
      break;
    case 16:
      hex(_CS_strm);
      break;
    default:
      _CS_strm.setf(ios_base::fmtflags(0), ios_base::basefield);
      break;
    }
  return _CS_strm;
}

template <class _CS_charT, class _CS_traits>
basic_istream<_CS_charT, _CS_traits>&
operator>> (basic_istream<_CS_charT, _CS_traits>& _CS_strm,
	    _CS_setbase const& _CS_b)
{
  switch (_CS_b._CS_base)
    {
    case 8:
      oct(_CS_strm);
      break;
    case 10:
      dec(_CS_strm);
      break;
    case 16:
      hex(_CS_strm);
      break;
    default:
      _CS_strm.setf(ios_base::fmtflags(0), ios_base::basefield);
      break;
    }
  return _CS_strm;
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_IOMANIP_CC__ */
