// -*-C++-*- srccxx/isbuf_it.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for istreambuf_iterator

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_ISBUF_IT_CC__)
#define __SRCCXX_ISBUF_IT_CC__ 1

#if !defined(_CXXRT_ISBUF_IT_H__)
#  include <cxxrt/sbuf_it.h>
#endif
#if !defined(_CXXRT_CTRAITS_H__)
#  include <cxxrt/ctraits.h>
#endif
#if !defined(_CXXRT_ISTREAM_H__)
#  include <cxxrt/istream.h>
#endif
#if !defined(_CXXRT_STREAMBUF_H__)
#  include <cxxrt/streambuf.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_traits>
inline bool
istreambuf_iterator<_CS_cT, _CS_traits>::_CS_get() const
{
  if (!_CS_m_is_cached)
    {
      return _CS_m_is_cached = !traits_type::eq_int_type(_CS_m_cache = _CS_m_sbuf->sgetc(), traits_type::eof());
    }
  else
    return true;
}

template <class _CS_cT, class _CS_traits>
inline bool
istreambuf_iterator<_CS_cT, _CS_traits>::_CS_valid() const
{
  return _CS_m_sbuf? _CS_get(): false;
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_traits>
inline
istreambuf_iterator<_CS_cT, _CS_traits>::istreambuf_iterator() throw():
  _CS_m_sbuf(0),
  _CS_m_is_cached(false)
{
}

template <class _CS_cT, class _CS_traits>
inline
istreambuf_iterator<_CS_cT, _CS_traits>::istreambuf_iterator(
    istreambuf_iterator<_CS_cT, _CS_traits>::streambuf_type* _CS_sb) throw():
  _CS_m_sbuf(_CS_sb),
  _CS_m_is_cached(false)
{
}

template <class _CS_cT, class _CS_traits>
inline
istreambuf_iterator<_CS_cT, _CS_traits>::istreambuf_iterator(
    istreambuf_iterator<_CS_cT, _CS_traits>::istream_type& _CS_is) throw():
  _CS_m_sbuf(_CS_is.rdbuf()),
  _CS_m_is_cached(false)
{
}

template <class _CS_charT, class _CS_traits>
inline
istreambuf_iterator<_CS_charT, _CS_traits>::istreambuf_iterator(
    istreambuf_iterator const& _CS_it):
  _CS_m_sbuf(_CS_it._CS_m_sbuf),
  _CS_m_is_cached(false)
{
}

template <class _CS_charT, class _CS_traits>
inline istreambuf_iterator<_CS_charT, _CS_traits>&
istreambuf_iterator<_CS_charT, _CS_traits>::operator= (istreambuf_iterator const& _CS_it)
{
  _CS_m_sbuf  = _CS_it._CS_m_sbuf;
  return *this;
}

template <class _CS_charT, class _CS_traits>
inline
istreambuf_iterator<_CS_charT, _CS_traits>::~istreambuf_iterator()
{
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_traits>
inline _CS_cT
istreambuf_iterator<_CS_cT, _CS_traits>::operator*() const
{
  _CS_get();
  return _CS_traits::to_char_type(_CS_m_cache);
}

template <class _CS_cT, class _CS_traits>
inline istreambuf_iterator<_CS_cT, _CS_traits>&
istreambuf_iterator<_CS_cT, _CS_traits>::operator++()
{
  _CS_m_sbuf->sbumpc();
  _CS_m_is_cached = false;
  return *this;
}

template <class _CS_cT, class _CS_traits>
inline istreambuf_iterator<_CS_cT, _CS_traits>::proxy
istreambuf_iterator<_CS_cT, _CS_traits>::operator++(int)
{
  _CS_get();
  proxy _CS_rc(_CS_m_cache);
  operator++();
  return _CS_rc;
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_traits>
inline bool
istreambuf_iterator<_CS_cT, _CS_traits>::equal(
  istreambuf_iterator<_CS_cT, _CS_traits> const& _CS_sb) const
{
#if 0
  if (_CS_m_sbuf != 0)
    {
      if (traits_type::eq_int_type(_CS_m_cache, traits_type::eof()))
	{
	  _CS_m_cache = _CS_m_sbuf->sgetc();
	  if (traits_type::eq_int_type(_CS_m_cache, traits_type::eof()))
	    _CS_m_sbuf = 0;
	}
    }

  if (_CS_sb._CS_m_sbuf != 0)
    {
      if (traits_type::eq_int_type(_CS_sb._CS_m_cache, traits_type::eof()))
	{
	  _CS_sb._CS_m_cache = _CS_sb._CS_m_sbuf->sgetc();
	  if (traits_type::eq_int_type(_CS_sb._CS_m_cache, traits_type::eof()))
	    _CS_sb._CS_m_sbuf = 0;
	}
    }

  return (_CS_sb._CS_m_sbuf == 0)? (_CS_m_sbuf == 0): (_CS_m_sbuf != 0);
#else
  return _CS_valid() == _CS_sb._CS_valid();
#endif
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_traits>
inline bool
operator== (istreambuf_iterator<_CS_cT, _CS_traits> const& _CS_sb1,
            istreambuf_iterator<_CS_cT, _CS_traits> const& _CS_sb2)
{
  return _CS_sb1.equal(_CS_sb2);
}

template <class _CS_cT, class _CS_traits>
inline bool
operator!= (istreambuf_iterator<_CS_cT, _CS_traits> const& _CS_sb1,
            istreambuf_iterator<_CS_cT, _CS_traits> const& _CS_sb2)
{
  return !_CS_sb1.equal(_CS_sb2);
}


// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_ISBUF_IT_CC__ */
