// -*-C++-*- srccxx/messages.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/messages category

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_MESSAGES_CC__)
#define __SRCCXX_MESSAGES_CC__ 1

#if !defined(_CXXRT_MESSAGES_H__)
#  include <cxxrt/messages.h>
#endif
#if !defined(_CXXRT_STRING_H__)
#  include <cxxrt/string.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT>
locale::id messages<_CS_cT>::id;

// --------------------------------------------------------------------------

template <class _CS_cT>
messages<_CS_cT>::messages(size_t _CS_refs):
	locale::facet(_CS_refs)
{
}

template <class _CS_cT>
messages<_CS_cT>::~messages()
{
}

template <class _CS_cT>
messages_base::catalog
messages<_CS_cT>::open(basic_string<char> const& _CS_cn, locale const& _CS_l) const
{
	return do_open(_CS_cn, _CS_l);
}

template <class _CS_cT>
messages<_CS_cT>::string_type
messages<_CS_cT>::get(catalog _CS_cat,
														int _CS_set,
														int _CS_msgid,
														basic_string<_CS_cT> const& _CS_dfault) const
{
	return do_get(_CS_cat, _CS_set, _CS_msgid, _CS_dfault);
}

template <class _CS_cT>
void
messages<_CS_cT>::close(catalog _CS_cat) const
{
	do_close(_CS_cat);
}

// --------------------------------------------------------------------------

template <class _CS_cT>
messages_base::catalog
messages<_CS_cT>::do_open(basic_string<char> const&,
																locale const&) const
{
	return 0; //-dk:TODO
}

template <class _CS_cT>
messages<_CS_cT>::string_type
messages<_CS_cT>::do_get(catalog,
															 int,
															 int,
															 basic_string<_CS_cT> const& _CS_dfault) const
{
	return _CS_dfault; //-dk:TODO
}

template <class _CS_cT>
void
messages<_CS_cT>::do_close(catalog) const
{
	//-dk:TODO
}

// --------------------------------------------------------------------------


template <class _CS_cT>
messages_byname<_CS_cT>::messages_byname(char const*,
																							 size_t _CS_refs):
	messages<_CS_cT>(_CS_refs)
{
	//-dk:TODO
}

template <class _CS_cT>
messages_byname<_CS_cT>::~messages_byname()
{
}

template <class _CS_cT>
messages_base::catalog
messages_byname<_CS_cT>::do_open(basic_string<char> const&,
																			 locale const&) const
{
	return 0; //-dk:TODO
}

template <class _CS_cT>
messages_byname<_CS_cT>::string_type
messages_byname<_CS_cT>::do_get(messages_base::catalog,
																			int,
																			int,
																			basic_string<_CS_cT> const& _CS_dfault) const
{
	return _CS_dfault; //-dk:TODO
}

template <class _CS_cT>
void
messages_byname<_CS_cT>::do_close(messages_base::catalog) const
{
	//-dk:TODO
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_MESSAGES_CC__ */
