// -*-C++-*- srccxx/money_get.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/money_get category

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_MONEY_GET_CC__)
#define __SRCCXX_MONEY_GET_CC__ 1

#if !defined(_CXXRT_MONEY_GET_H__)
#  include <cxxrt/money_get.h>
#endif
#if !defined(_CXXRT_SBUF_IT_H__)
#  include <cxxrt/sbuf_it.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
locale::id money_get<_CS_cT, _CS_It>::id;

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
money_get<_CS_cT, _CS_It>::money_get(size_t _CS_refs):
	locale::facet(_CS_refs)
{
}

template <class _CS_cT, class _CS_It>
money_get<_CS_cT, _CS_It>::~money_get()
{
}

template <class _CS_cT, class _CS_It>
money_get<_CS_cT, _CS_It>::iter_type
money_get<_CS_cT, _CS_It>::get(iter_type          _CS_b,
																					 iter_type          _CS_e,
																					 bool               _CS_intl,
																					 ios_base&          _CS_fmt,
																					 ios_base::iostate& _CS_err,
																					 long double&       _CS_units) const
{
	return do_get(_CS_b, _CS_e, _CS_intl,
								_CS_fmt, _CS_err, _CS_units);
}

template <class _CS_cT, class _CS_It>
money_get<_CS_cT, _CS_It>::iter_type
money_get<_CS_cT, _CS_It>::get(iter_type          _CS_b,
																					 iter_type          _CS_e,
																					 bool               _CS_intl,
																					 ios_base&          _CS_fmt,
																					 ios_base::iostate& _CS_err,
																					 string_type&       _CS_digits) const
{
	return do_get(_CS_b, _CS_e, _CS_intl,
								_CS_fmt, _CS_err, _CS_digits);
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
money_get<_CS_cT, _CS_It>::iter_type
money_get<_CS_cT, _CS_It>::do_get(iter_type _CS_b,
																							iter_type,
																							bool,
																							ios_base&,
																							ios_base::iostate&,
																							long double&) const
{
	return _CS_b;
}

template <class _CS_cT, class _CS_It>
money_get<_CS_cT, _CS_It>::iter_type
money_get<_CS_cT, _CS_It>::do_get(iter_type _CS_b,
																							iter_type,
																							bool,
																							ios_base&,
																							ios_base::iostate&,
																							string_type&) const
{
	return _CS_b;
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_MONEY_GET_CC__ */
