// -*-C++-*- srccxx/money_put.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/money_put category

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_MONY_PUT_CC__)
#define __SRCCXX_MONY_PUT_CC__ 1

#if !defined(_CXXRT_MONY_PUT_H__)
#  include <cxxrt/money_put.h>
#endif
#if !defined(_CXXRT_SBUF_IT_H__)
#  include <cxxrt/sbuf_it.h>
#endif
#if !defined(_CXXRT_STRING_H__)
#  include <cxxrt/string.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
locale::id money_put<_CS_cT, _CS_It>::id;

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
money_put<_CS_cT, _CS_It>::money_put(size_t _CS_refs):
  locale::facet(_CS_refs)
{
}

template <class _CS_cT, class _CS_It>
money_put<_CS_cT, _CS_It>::~money_put()
{
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
money_put<_CS_cT, _CS_It>::iter_type
money_put<_CS_cT, _CS_It>::put(iter_type _CS_b,
                                           bool _CS_intl,
                                           ios_base& _CS_fmt,
                                           char_type _CS_fill,
                                           long double _CS_units) const
{
  return do_put(_CS_b, _CS_intl, _CS_fmt, _CS_fill, _CS_units);
}

template <class _CS_cT, class _CS_It>
money_put<_CS_cT, _CS_It>::iter_type
money_put<_CS_cT, _CS_It>::put(iter_type _CS_b,
                                           bool _CS_intl,
                                           ios_base& _CS_fmt,
                                           char_type _CS_fill,
                                           string_type const& _CS_units) const
{
  return do_put(_CS_b, _CS_intl, _CS_fmt, _CS_fill, _CS_units);
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
money_put<_CS_cT, _CS_It>::iter_type
money_put<_CS_cT, _CS_It>::do_put(iter_type _CS_b,
                                              bool,
                                              ios_base&,
                                              char_type,
                                              long double) const
{
  return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
money_put<_CS_cT, _CS_It>::iter_type
money_put<_CS_cT, _CS_It>::do_put(iter_type _CS_b,
                                              bool,
                                              ios_base&,
                                              char_type,
                                              string_type const&) const
{
  return _CS_b; //-dk:TODO
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_MONY_PUT_CC__ */
