// -*-C++-*- srccxx/moneypunct.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/moneypunct category

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_MONEYPUNCT_CC__)
#define __SRCCXX_MONEYPUNCT_CC__ 1

#if !defined(_CXXRT_MONEYPUNCT_H__)
#  include <cxxrt/moneypunct.h>
#endif
#if !defined(_CXXRT_STRING_H__)
#  include <cxxrt/string.h>
#endif
#if !defined(_CXXRT_ALLOC_H__)
#  include <cxxrt/alloc.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, bool _CS_Intl>
locale::id moneypunct<_CS_cT, _CS_Intl>::id;
#if _CXXRT_HAS_CONST_EXPRESSION_MEMBER == 1
template <class _CS_cT, bool _CS_Intl>
bool const moneypunct<_CS_cT, _CS_Intl>::intl;
#endif

// --------------------------------------------------------------------------

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::moneypunct(size_t _CS_refs):
  locale::facet(_CS_refs)
{
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::~moneypunct()
{
}

// --------------------------------------------------------------------------

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::char_type
moneypunct<_CS_cT, _CS_Intl>::decimal_point() const
{
  return do_decimal_point();
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::char_type         
moneypunct<_CS_cT, _CS_Intl>::thousands_sep() const
{
  return do_thousands_sep();
}

template <class _CS_cT, bool _CS_Intl>
basic_string<char>
moneypunct<_CS_cT, _CS_Intl>::grouping() const
{
  return do_grouping();
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::string_type
moneypunct<_CS_cT, _CS_Intl>::curr_symbol() const
{
  return do_curr_symbol();
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::string_type
moneypunct<_CS_cT, _CS_Intl>::positive_sign() const
{
  return do_positive_sign();
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::string_type
moneypunct<_CS_cT, _CS_Intl>::negative_sign() const
{
  return do_negative_sign();
}

template <class _CS_cT, bool _CS_Intl>
int       
moneypunct<_CS_cT, _CS_Intl>::frac_digits() const
{
  return do_frac_digits();
}

template <class _CS_cT, bool _CS_Intl>
money_base::pattern  
moneypunct<_CS_cT, _CS_Intl>::pos_format() const
{
  return do_pos_format();
}

template <class _CS_cT, bool _CS_Intl>
money_base::pattern 
moneypunct<_CS_cT, _CS_Intl>::neg_format() const
{
  return do_pos_format();
}

// --------------------------------------------------------------------------

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::char_type   
moneypunct<_CS_cT, _CS_Intl>::do_decimal_point() const
{
  return char_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::char_type  
moneypunct<_CS_cT, _CS_Intl>::do_thousands_sep() const
{
  return char_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
basic_string<char>
moneypunct<_CS_cT, _CS_Intl>::do_grouping() const
{
  return basic_string<char>(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::string_type
moneypunct<_CS_cT, _CS_Intl>::do_curr_symbol() const
{
  return string_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::string_type
moneypunct<_CS_cT, _CS_Intl>::do_positive_sign() const
{
  return string_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct<_CS_cT, _CS_Intl>::string_type
moneypunct<_CS_cT, _CS_Intl>::do_negative_sign() const
{
  return string_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
int       
moneypunct<_CS_cT, _CS_Intl>::do_frac_digits() const
{
  return int(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
money_base::pattern  
moneypunct<_CS_cT, _CS_Intl>::do_pos_format() const
{
  return pattern(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
money_base::pattern 
moneypunct<_CS_cT, _CS_Intl>::do_neg_format() const
{
  return pattern(); //-dk:TODO
}

// --------------------------------------------------------------------------

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::moneypunct_byname(char const*, size_t _CS_refs):
  moneypunct<_CS_cT, _CS_Intl>(_CS_refs)
{
  //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::~moneypunct_byname()
{
}

// --------------------------------------------------------------------------

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::char_type   
moneypunct_byname<_CS_cT, _CS_Intl>::do_decimal_point() const
{
  return char_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::char_type  
moneypunct_byname<_CS_cT, _CS_Intl>::do_thousands_sep() const
{
  return char_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
basic_string<char>
moneypunct_byname<_CS_cT, _CS_Intl>::do_grouping() const
{
  return basic_string<char>(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::string_type
moneypunct_byname<_CS_cT, _CS_Intl>::do_curr_symbol() const
{
  return string_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::string_type
moneypunct_byname<_CS_cT, _CS_Intl>::do_positive_sign() const
{
  return string_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
moneypunct_byname<_CS_cT, _CS_Intl>::string_type
moneypunct_byname<_CS_cT, _CS_Intl>::do_negative_sign() const
{
  return string_type(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
int       
moneypunct_byname<_CS_cT, _CS_Intl>::do_frac_digits() const
{
  return int(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
money_base::pattern  
moneypunct_byname<_CS_cT, _CS_Intl>::do_pos_format() const
{
  return pattern(); //-dk:TODO
}

template <class _CS_cT, bool _CS_Intl>
money_base::pattern 
moneypunct_byname<_CS_cT, _CS_Intl>::do_neg_format() const
{
  return pattern(); //-dk:TODO
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_MONEYPUNCT_CC__ */
