// -*-C++-*- srccxx/osbuf_it.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for ostreambuf_iterator

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_OSBUF_IT_CC__)
#define __SRCCXX_OSBUF_IT_CC__ 1

#if !defined(_CXXRT_SBUF_IT_H__)
#  include <cxxrt/sbuf_it.h>
#endif
#if !defined(_CXXRT_CTRAITS_H__)
#  include <cxxrt/ctraits.h>
#endif
#if !defined(_CXXRT_OSTREAM_H__)
#  include <cxxrt/ostream.h>
#endif
#if !defined(_CXXRT_STREAMBUF_H__)
#  include <cxxrt/streambuf.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>::ostreambuf_iterator(
    ostreambuf_iterator<_CS_charT, _CS_traits>::streambuf_type *_CS_sb) throw():
  _CS_m_sbuf(_CS_sb),
  _CS_fail(false)
{
}

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>::ostreambuf_iterator(
    ostreambuf_iterator<_CS_charT, _CS_traits>::ostream_type& _CS_os) throw():
  _CS_m_sbuf(_CS_os.rdbuf()),
  _CS_fail(false)
{
}

#if 0
template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>::ostreambuf_iterator(
    ostreambuf_iterator const& _CS_it) throw():
  _CS_m_sbuf(_CS_it._CS_m_sbuf),
  _CS_fail(_CS_it._CS_fail)
{
}
#endif

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>&
ostreambuf_iterator<_CS_charT, _CS_traits>::operator= (
    ostreambuf_iterator const& _CS_it) throw()
{
  _CS_m_sbuf = _CS_it._CS_m_sbuf;
  _CS_fail = _CS_it._CS_fail;
  return *this;
}

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>::~ostreambuf_iterator() throw()
{
}

// --------------------------------------------------------------------------

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>&
ostreambuf_iterator<_CS_charT, _CS_traits>::operator*() throw()
{
  return *this;
}

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>&
ostreambuf_iterator<_CS_charT, _CS_traits>::operator= (_CS_charT _CS_c)
{
  if (_CS_traits::eq_int_type(_CS_m_sbuf->sputc(_CS_c), _CS_traits::eof()))
    _CS_fail = true;
  return *this;
}

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>&
ostreambuf_iterator<_CS_charT, _CS_traits>::operator++ () throw()
{
  return *this;
}

template <class _CS_charT, class _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>
ostreambuf_iterator<_CS_charT, _CS_traits>::operator++ (int) throw()
{
  return *this;
}

template <class _CS_charT, class _CS_traits>
bool
ostreambuf_iterator<_CS_charT, _CS_traits>::failed() const throw()
{
  return _CS_fail;
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_OSBUF_IT_CC__ */
