// -*-C++-*- srccxx/time_get.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/time_get category

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_TIME_GET_CC__)
#define __SRCCXX_TIME_GET_CC__ 1

#if !defined(_CXXRT_TIME_GET_H__)
#  include <cxxrt/time_get.h>
#endif
#if !defined(_CXXRT_SBUF_IT_H__)
#  include <cxxrt/sbuf_it.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
locale::id time_get<_CS_cT, _CS_It>::id;

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::time_get(size_t _CS_refs):
	locale::facet(_CS_refs)
{
}

template <class _CS_cT, class _CS_It>
time_base::dateorder
time_get<_CS_cT, _CS_It>::date_order() const
{
	return do_date_order();
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::get_time(iter_type          _CS_b,
																							 iter_type          _CS_e,
																							 ios_base&          _CS_fmt,
																							 ios_base::iostate& _CS_err,
																							 tm*                _CS_tm) const
{
	return do_get_time(_CS_b, _CS_e, _CS_fmt, _CS_err, _CS_tm);
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::get_date(iter_type          _CS_b,
																							 iter_type          _CS_e,
																							 ios_base&          _CS_fmt,
																							 ios_base::iostate& _CS_err,
																							 tm*                _CS_tm) const
{
	return do_get_time(_CS_b, _CS_e, _CS_fmt, _CS_err, _CS_tm);
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::get_weekday(iter_type          _CS_b,
																									iter_type          _CS_e,
																									ios_base&          _CS_fmt,
																									ios_base::iostate& _CS_err,
																									tm*                _CS_tm) const
{
	return do_get_time(_CS_b, _CS_e, _CS_fmt, _CS_err, _CS_tm);
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::get_monthname(iter_type          _CS_b,
																										iter_type          _CS_e,
																										ios_base&          _CS_fmt,
																										ios_base::iostate& _CS_err,
																										tm*                _CS_tm) const
{
	return do_get_time(_CS_b, _CS_e, _CS_fmt, _CS_err, _CS_tm);
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::get_year(iter_type          _CS_b,
																							 iter_type          _CS_e,
																							 ios_base&          _CS_fmt,
																							 ios_base::iostate& _CS_err,
																							 tm*                _CS_tm) const
{
	return do_get_time(_CS_b, _CS_e, _CS_fmt, _CS_err, _CS_tm);
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
time_base::dateorder
time_get<_CS_cT, _CS_It>::do_date_order() const
{
	return dateorder(); //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::do_get_time(iter_type _CS_b,
																									iter_type,
																									ios_base&,
																									ios_base::iostate&,
																									tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::do_get_date(iter_type _CS_b,
																									iter_type,
																									ios_base&,
																									ios_base::iostate&,
																									tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::do_get_weekday(iter_type _CS_b,
																										 iter_type,
																										 ios_base&,
																										 ios_base::iostate&,
																										 tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::do_get_monthname(iter_type _CS_b,
																											 iter_type,
																											 ios_base&,
																											 ios_base::iostate&,
																											 tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get<_CS_cT, _CS_It>::iter_type
time_get<_CS_cT, _CS_It>::do_get_year(iter_type _CS_b,
																									iter_type,
																									ios_base&,
																									ios_base::iostate&,
																									tm*) const
{
	return _CS_b; //-dk:TODO
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
time_get_byname<_CS_cT, _CS_It>::time_get_byname(char const*,
																														 size_t _CS_refs):
	time_get<_CS_cT, _CS_It>(_CS_refs)
{
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
time_base::dateorder
time_get_byname<_CS_cT, _CS_It>::do_date_order() const
{
	return dateorder(); //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get_byname<_CS_cT, _CS_It>::iter_type
time_get_byname<_CS_cT, _CS_It>::do_get_time(iter_type _CS_b,
																												 iter_type,
																												 ios_base&,
																												 ios_base::iostate&,
																												 tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get_byname<_CS_cT, _CS_It>::iter_type
time_get_byname<_CS_cT, _CS_It>::do_get_date(iter_type _CS_b,
																												 iter_type,
																												 ios_base&,
																												 ios_base::iostate&,
																												 tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get_byname<_CS_cT, _CS_It>::iter_type
time_get_byname<_CS_cT, _CS_It>::do_get_weekday(iter_type _CS_b,
																														iter_type,
																														ios_base&,
																														ios_base::iostate&,
																														tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get_byname<_CS_cT, _CS_It>::iter_type
time_get_byname<_CS_cT, _CS_It>::do_get_monthname(iter_type _CS_b,
																															iter_type,
																															ios_base&,
																															ios_base::iostate&,
																															tm*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_get_byname<_CS_cT, _CS_It>::iter_type
time_get_byname<_CS_cT, _CS_It>::do_get_year(iter_type _CS_b,
																												 iter_type,
																												 ios_base&,
																												 ios_base::iostate&,
																												 tm*) const
{
	return _CS_b; //-dk:TODO
}


// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_TIME_GET_CC__ */
