// -*-C++-*- srccxx/time_put.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementations for the srccxx/time_put category

// -------------------------------------------------------------------------- 

#if !defined(__SRCCXX_TIME_PUT_CC__)
#define __SRCCXX_TIME_PUT_CC__ 1

#if !defined(_CXXRT_TIME_PUT_H__)
#  include <cxxrt/time_put.h>
#endif
#if !defined(_CXXRT_SBUF_IT_H__)
#  include <cxxrt/sbuf_it.h>
#endif

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
locale::id time_put<_CS_cT, _CS_It>::id;

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
time_put<_CS_cT, _CS_It>::time_put(size_t _CS_refs):
	locale::facet(_CS_refs)
{
}

template <class _CS_cT, class _CS_It>
time_put<_CS_cT, _CS_It>::iter_type
time_put<_CS_cT, _CS_It>::put(iter_type _CS_b,
																					ios_base&,
																					char_type,
																					tm const*,
																					char_type const*,
																					char_type const*) const
{
	return _CS_b; //-dk:TODO
}

template <class _CS_cT, class _CS_It>
time_put<_CS_cT, _CS_It>::iter_type
time_put<_CS_cT, _CS_It>::put(iter_type _CS_b,
																					ios_base& _CS_fmt,
																					char_type _CS_fill,
																					tm const* _CS_time,
																					char      _CS_format,
																					char      _CS_mod) const
{
	return do_put(_CS_b, _CS_fmt, _CS_fill, _CS_time, _CS_format, _CS_mod);
}

template <class _CS_cT, class _CS_It>
time_put<_CS_cT, _CS_It>::iter_type
time_put<_CS_cT, _CS_It>::do_put(iter_type _CS_b,
																						 ios_base&,
																						 char_type,
																						 tm const*,
																						 char,
																						 char) const
{
	return _CS_b; //-dk:TODO
}

// --------------------------------------------------------------------------

template <class _CS_cT, class _CS_It>
time_put_byname<_CS_cT, _CS_It>::time_put_byname(char const *, size_t)
{
}

template <class _CS_cT, class _CS_It>
time_put_byname<_CS_cT, _CS_It>::iter_type
time_put_byname<_CS_cT, _CS_It>::do_put(iter_type _CS_b,
																										ios_base&,
																										char_type,
																										tm const*,
																										char,
																										char) const
{
	return _CS_b; //-dk:TODO
}

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_END

#endif /* __SRCCXX_TIME_PUT_CC__ */
