// -*-C++-*- ciobj.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Definition of the standard input stream object

// -------------------------------------------------------------------------- 

#include <cxxrt/ctraits.h>
#include <iostream>
#include <cstdio>
#include <cstring>
#include <streambuf>
#include <cassert>
#include <cstdlib>

// -------------------------------------------------------------------------- 

//-dk:TODO
#if 0 && !defined(_CXXRT_STANDALONE)

_CXXRT_NAMESPACE_BEGIN
  extern streamsize _CS_std_bufsize;
_CXXRT_NAMESPACE_END

namespace {
  class cstdiobuf: public _CXXRT_STD basic_streambuf<char, _CXXRT_STD char_traits<char> >
  {
  public:
    cstdiobuf(_CXXRT_STD FILE *f);

  protected:
    int_type   underflow();

  private:
    cstdiobuf(cstdiobuf const&);
    void operator= (cstdiobuf const&);

    _CXXRT_STD FILE* m_file;
    char             m_char[65536];
  };

  cstdiobuf::cstdiobuf(::_CXXRT_STD_NAME::FILE *f):
    m_file(f)
  {
    setg(m_char, m_char + 1, m_char + 1);
  }

  _CXXRT_STD basic_ios<char, _CXXRT_STD char_traits<char> >::int_type cstdiobuf::underflow()
  {
    using _CS_swamp::_impure_ptr;
    if (eback() == egptr())
	return _CXXRT_STD char_traits<char>::eof();
      
    _CXXRT_STD streamsize sz = _CXXRT_STD fread(m_char, 1, _CXXRT_STD _CS_std_bufsize, stdin);
    setg(m_char, m_char, m_char + sz);
    return sz > 0? _CXXRT_STD char_traits<char>::to_int_type(m_char[0]): _CXXRT_STD char_traits<char>::eof();
  }
}

// -------------------------------------------------------------------------- 

_CXXRT_NAMESPACE_BEGIN

using _CS_swamp::_impure_ptr;
basic_istream<char, char_traits<char> > cin(new cstdiobuf(stdin), &cout);

_CXXRT_NAMESPACE_END
#else

// #include <unistd.h>
extern "C" int read(int, char*, int);

namespace
{
  class stdiobuf:
    public _CXXRT_STD streambuf
  {
  public:
    stdiobuf(int fd): m_fd(fd) {}
  private:
    int_type underflow()
    {
      if (gptr() == egptr())
	{
	  std::streamsize size = read(m_fd, m_buffer, s_size);
	  if (size > 0)
	    setg(m_buffer, m_buffer, m_buffer + size);
	}

      return gptr() == egptr()? traits_type::eof(): traits_type::to_int_type(*gptr());
    }

    int m_fd;
    enum { s_size = 256 };
    char m_buffer[s_size];
  };

  stdiobuf _Cxxrt_cinbuf(0);
}

_CXXRT_NAMESPACE_BEGIN

istream cin(&_Cxxrt_cinbuf);

_CXXRT_NAMESPACE_END

#endif
