// -*-C++-*- src/cnumpunc.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Specialized implementation of numpunct<char> 

// -------------------------------------------------------------------------- 

#include <srccxx/numpunct.cc>
#include <cxxrt/ctraits.h>
#include <cxxrt/string.h>

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------- 

template <>
numpunct<char>::char_type
numpunct<char>::do_decimal_point() const
{
  return '.';
}

template <>
numpunct<char>::char_type
numpunct<char>::do_thousands_sep() const
{
  return ',';
}

template<>
numpunct<char>::string_type
numpunct<char>::do_truename() const
{
  return string_type("true");
}

template<>
numpunct<char>::string_type
numpunct<char>::do_falsename() const
{
  return string_type("false");
}

// --------------------------------------------------------------------------

template class numpunct<char>;
template class numpunct_byname<char>;

// -------------------------------------------------------------------------- 

_CXXRT_NAMESPACE_END
