// -*-C++-*- failure.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1998 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementation of the ios_base::failure

// -------------------------------------------------------------------------- 

#include <cxxrt/ios_base.h>
#include <cxxrt/string.h>
#include <cstring>

// -------------------------------------------------------------------------- 

static char const *__cxxrt_strdup(char const *str)
{
  char *rc = new char[_CXXRT_STD_NAME::strlen(str) + 1];
  return _CXXRT_STD_NAME::strcpy(rc, str);
}

// -------------------------------------------------------------------------- 

_CXXRT_STD_NAME:: ios_base::failure::failure(char const* msg):
  ::std::exception(),
  _CS_message(__cxxrt_strdup(msg))
{
}

_CXXRT_STD_NAME:: ios_base::failure::failure(_CXXRT_STD string const &msg):
  ::std::exception(),
  _CS_message(__cxxrt_strdup(msg.c_str()))
{
}

_CXXRT_STD_NAME::
ios_base::failure::failure(_CXXRT_STD ios_base::failure const &f):
  ::std::exception(f),
  _CS_message(__cxxrt_strdup(f._CS_message))
{
}

_CXXRT_STD ios_base::failure &
_CXXRT_STD_NAME:: ios_base::failure::operator= (_CXXRT_STD ios_base::failure const &f)
{
  if (this != & f)
    {
      delete [] const_cast<char*>(_CS_message);
      _CS_message = __cxxrt_strdup(f._CS_message);
    }
  return *this;
}

_CXXRT_STD_NAME:: ios_base::failure::~failure() throw()
{
  delete [] const_cast<char*>(_CS_message);
}

char const *_CXXRT_STD_NAME:: ios_base::failure::what() const throw()
{
  return _CS_message;
}
