// -*-C++-*- iomanip.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementation of the iomanip stuff.

// -------------------------------------------------------------------------- 

#include <srccxx/iomanip.cc>

// --------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------- 

_CS_resetiosflags resetiosflags(ios_base::fmtflags _CS_f)
{
  return _CS_resetiosflags(_CS_f);
}

void _CS_resetiosflags_fct(ios_base &_CS_strm, _CS_resetiosflags const &_CS_f)
{
  _CS_strm.setf(ios_base::fmtflags(0), _CS_f._CS_flags);
}

// -------------------------------------------------------------------------- 

_CS_setiosflags setiosflags(ios_base::fmtflags _CS_f)
{
  return _CS_setiosflags(_CS_f);
}

void _CS_setiosflags_fct(ios_base &_CS_strm, _CS_setiosflags const &_CS_f)
{
  _CS_strm.setf(_CS_f._CS_flags);
}

// -------------------------------------------------------------------------- 

_CS_setbase setbase(int _CS_b)
{
  return _CS_setbase(_CS_b);
}

void _CS_setbase_fct(ios_base &_CS_strm, _CS_setbase const &_CS_b)
{
  switch (_CS_b._CS_base)
    {
    case 8: _CS_strm.setf(ios_base::oct, ios_base::basefield); break;
    case 10: _CS_strm.setf(ios_base::dec, ios_base::basefield); break;
    case 16: _CS_strm.setf(ios_base::hex, ios_base::basefield); break;
    default: _CS_strm.setf(ios_base::fmtflags(0), ios_base::basefield); break;
    }
}

// -------------------------------------------------------------------------- 

_CS_setprecision setprecision(int _CS_p)
{
  return _CS_setprecision(_CS_p);
}

// -------------------------------------------------------------------------- 

_CS_setw setw(int _CS_w)
{
  return _CS_setw(_CS_w);
}

void _CS_setw_fct(ios_base &_CS_strm, _CS_setw const &_CS_w)
{
  _CS_strm.width(_CS_w._CS_width);
}

// -------------------------------------------------------------------------- 

_CXXRT_NAMESPACE_END
