// -*-C++-*- lclassic.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Implementation of the "classic" locale

// The classic C locale is the only required locale in the standard C++
// library. It contains a bunch of facets which are constructed here.

// -------------------------------------------------------------------------- 

#include <locale>
#include <cxxrt/string.h>
#include <cxxrt/lcache.h>

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------- 

locale::_CS_intern*
// locale::locale::_CS_classic_rep()
_CS_classic_rep()
{
  static locale::_CS_intern* rc = 0;
  static bool              init = true;

  if (init)
    {
      rc = new locale::_CS_intern("C");
      ++rc->_CS_m_refcount; // one for the reference "rc"...
      ++rc->_CS_m_refcount; // ... and one for the classic locale

#if !defined(_CXXRT_USE_FACET_INSTALLS)
      numpunct<char> *np1 = new numpunct<char>;
      np1->_CS_preprocess();
      rc->_CS_add(np1);

      // rc->_CS_add(new num_put<char, char*>);
      // rc->_CS_add(new num_get<char, char const *>);

      rc->_CS_add(new numpunct<wchar_t>);
      rc->_CS_add(new _CXXRT_STD collate<char>);
      rc->_CS_add(new _CXXRT_STD collate<wchar_t>);

      rc->_CS_add(new _CXXRT_STD ctype<char>);
      rc->_CS_add(new _CXXRT_STD ctype<wchar_t>);
      rc->_CS_add(new codecvt<char, char, mbstate_t>);
      rc->_CS_add(new codecvt<wchar_t, char, mbstate_t>);
      rc->_CS_add(new moneypunct<char, false>);
      rc->_CS_add(new moneypunct<char, true>);
      //-dk:TOD rc->_CS_add(new moneypunct<wchar_t, false>);
      //-dk:TOD rc->_CS_add(new moneypunct<wchar_t, true>);
      rc->_CS_add(new money_get<char>);
      rc->_CS_add(new money_get<wchar_t>);
      rc->_CS_add(new money_put<char>);
      rc->_CS_add(new money_put<wchar_t>);
      rc->_CS_add(new num_get<char>);
      rc->_CS_add(new num_get<wchar_t>);
      rc->_CS_add(new num_put<char>);
      rc->_CS_add(new num_put<wchar_t>);
      rc->_CS_add(new time_get<char>);
      rc->_CS_add(new time_get<wchar_t>);
      rc->_CS_add(new time_put<char>);
      rc->_CS_add(new time_put<wchar_t>);
      rc->_CS_add(new _CXXRT_STD messages<char>);
      rc->_CS_add(new _CXXRT_STD messages<wchar_t>);

      // the next two facets should be installed by the numpunct facet...
      rc->_CS_add(new _CS_cache<char>);
      rc->_CS_add(new _CS_cache<wchar_t>);
#endif

      init = false;
    }

  rc->_CS_init();

  return rc;
}

locale const &locale::classic()
{
  static locale rc(_CS_classic_rep());
  return rc;
}

// -----------------------------------------------------------------------------
_CXXRT_NAMESPACE_END
