// -*-C++-*- num_putf.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:   

// -------------------------------------------------------------------------- 

#include <cxxrt/num_put.h>
#include <cxxrt/ios_base.h>
#include <cxxrt/string.h>
#include <cstdio>

// -------------------------------------------------------------------------

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------- 

static string num_put_format(ios_base &fmt, double value)
{
  char buffer[1024];

  static char const* formats[] = {
    " %.*e", " %+.*e", " %#.*e", " %#+.*e",
    " %.*f", " %+.*f", " %#.*f", " %#+.*f",
    " %.*g", " %+.*g", " %#.*g", " %#+.*g",

    "%.*e ", "%+.*e ", "%#.*e ", "%#+.*e ",
    "%.*f ", "%+.*f ", "%#.*f ", "%#+.*f ",
    "%.*g ", "%+.*g ", "%#.*g ", "%#+.*g ",
  };

  int index = (fmt.flags() & ios_base::showpos? 1: 0)
    + (fmt.flags() & ios_base::showpoint? 2: 0);

  switch (fmt.flags() & ios_base::floatfield)
    {
    case ios_base::scientific:
      break;
    case ios_base::fixed:
      index += 4;
      break;
    default:
      index += 8;
      break;
    }

  switch (fmt.flags() & ios_base::adjustfield)
    {
    case ios_base::left:
      index += 12;
      break;
    case ios_base::internal:
      index += 12;
      break;
    case ios_base::right:
    default:
      break;
    }
      
  // ecvt(value, fmt.precision(), buffer);
  // gcvt(value, fmt.precision(), buffer);
  // sprintf(buffer, formats[index], (int)fmt.precision(), value);
  strcpy(buffer, "-dk:TODO!");

  return buffer;
}

// -------------------------------------------------------------------------- 

string __do_num_put(ios_base &fmt, float value)
{
  return num_put_format(fmt, value);
}

string __do_num_put(ios_base &fmt, double value)
{
  return num_put_format(fmt, value);
}

string __do_num_put(ios_base &fmt, long double value)
{
  return num_put_format(fmt, static_cast<double>(value));
}

// -------------------------------------------------------------------------- 

_CXXRT_NAMESPACE_END
