// -*-C++-*- src/wnumpunc.cc
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 1997 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  Specialized implementation of numpunct<wchar_t> 

// -------------------------------------------------------------------------- 

#include <srccxx/numpunct.cc>
#include <cxxrt/ctraits.h>
#include <cxxrt/string.h>

_CXXRT_NAMESPACE_BEGIN

// -------------------------------------------------------------------------- 

template <>
numpunct<wchar_t>::char_type
numpunct<wchar_t>::do_decimal_point() const
{
  return L'.';
}

template <>
numpunct<wchar_t>::char_type
numpunct<wchar_t>::do_thousands_sep() const
{
  return L',';
}

template<>
numpunct<wchar_t>::string_type
numpunct<wchar_t>::do_truename() const
{
  return string_type(L"true");
}

template<>
numpunct<wchar_t>::string_type
numpunct<wchar_t>::do_falsename() const
{
  return string_type(L"false");
}

// --------------------------------------------------------------------------

template class numpunct<wchar_t>;
template class numpunct_byname<wchar_t>;

// -------------------------------------------------------------------------- 

_CXXRT_NAMESPACE_END
