/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference"
 * by Nicolai M. Josuttis, Addison-Wesley, 1999
 *
 * (C) Copyright Nicolai M. Josuttis 1999.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <istream>
#include <limits>
#if defined(_CXXRT_STD_NAME) 
#  define STD_NAME _CXXRT_STD_NAME 
#else 
#  define STD_NAME std 
#endif

template <class charT, class traits>
inline
STD_NAME::basic_istream<charT,traits>&
ignoreLine (STD_NAME::basic_istream<charT,traits>& strm)
{
    // skip until end-of-line
    strm.ignore(STD_NAME::numeric_limits<int>::max(),strm.widen('\n'));

    // return stream for concatenation
    return strm;
}
