// -*-C++-*- include/testtools.hpp
// <!!----------------------------------------------------------------------> 
// <!! Copyright (C) 2000 Dietmar Kuehl, Claas Solutions GmbH > 
// <!!> 
// <!! Permission to use, copy, modify, distribute and sell this > 
// <!! software for any purpose is hereby granted without fee, provided > 
// <!! that the above copyright notice appears in all copies and that > 
// <!! both that copyright notice and this permission notice appear in > 
// <!! supporting documentation. Dietmar Kuehl and Claas Solutions make no > 
// <!! representations about the suitability of this software for any > 
// <!! purpose. It is provided "as is" without express or implied warranty. > 
// <!!----------------------------------------------------------------------> 

// Author: Dietmar Kuehl dietmar.kuehl@claas-solutions.de 
// Title:  stuff to simplify testing
// Version: $Id: testtools.hpp,v 1.3 2000/07/15 07:51:33 kuehl Exp $ 

// -------------------------------------------------------------------------- 

#if !defined(INCLUDE_TESTTOOLS_HPP)
#define INCLUDE_TESTTOOLS_HPP 1

// -------------------------------------------------------------------------- 

#include <iostream>

// -------------------------------------------------------------------------- 

template <class T> inline void use(T&) {}
template <class T> inline void const_use(T const&) {}

template <class T> inline void check_type(T&) {}
template <class T> inline void check_fct_type(T const&) {}

template <class T> inline void test_type() { T* ptr = 0; use(ptr); }

template <class T> struct aux {};
template <class S, class T> inline void compare_types() 
{
  aux<S>  s;
  aux<T>& t = s;
  use(t);
}

bool settrue(bool& b) { return b = true; }

// -------------------------------------------------------------------------- 

namespace _Estd_safe {
  using std::cout;
}

// -------------------------------------------------------------------------- 

#endif /* INCLUDE_TESTTOOLS_HPP */
